\section{Query Answering}

\begin{frame}{Knowledge Graphs}
    \centering
    \input{ikg.tex}
\end{frame}

\begin{frame}{Conjunctive Queries (CQs)}

    ``In which genres are the books written by Stephen King?''
        \begin{align*}
            ?G : \exists B.wrote(\mathsf{King}, B) \land hasGenre(B, G)
        \end{align*}

        \centering\input{cqgraph.tex}
\end{frame}

\begin{frame}{Existential Positive First-Order Queries (EPFOs)}

    ``Which authors have books in the genre horror \textbf{or} science-fiction?''
        \begin{align*}
            ?A : \exists &B.(wrote(A, B) \land \\
             &(hasGenre(B, \mathsf{Horror}) \lor hasGenre(B, \mathsf{SciFi})))
        \end{align*}
   
        \centering\input{epfograph.tex}
\end{frame}

\begin{frame}{EPFOs and CQs}
    EPFOs are equivalent to unions of CQs: 
    \begin{align*}
        &\{?A : \exists  B.(wrote(A, B) \land B.hasGenre(B, \mathsf{Horror}))\}\cup\\
        &\{?A : \exists  B.(wrote(A, B) \land B.hasGenre(B, \mathsf{SciFi}))\}
    \end{align*}
\end{frame}

\begin{frame}{Answering the Query}

    ``In which genres are the books written by Stephen King?''
        \begin{align*}
            ?G : \exists B.wrote(\mathsf{King}, B) \land hasGenre(B, G)
        \end{align*}

        \centering\input{ikg_cq.tex}
    
\end{frame}

